

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.FileInputStream;

import javax.media.Buffer;
import javax.media.Effect;
import javax.media.Format;
import javax.media.ResourceUnavailableException;
import javax.media.format.RGBFormat;
import javax.swing.ImageIcon;

import com.sun.image.codec.jpeg.JPEGCodec;
import com.sun.image.codec.jpeg.JPEGImageDecoder;

/**
 * @author Horst Eidenberger (hme@ims.tuwien.ac.at), adaptation: Heinrich
 *         Hussmann, Bettina Conradi
 * @version 1
 */

public class GreyEffect implements Effect {

	private Format inputFormat;
	private Format outputFormat;
	private Format[] inputFormats;
	private Format[] outputFormats;


	public synchronized int process(Buffer in, Buffer out) {

		//TODO: eigenen process-Effekt implementieren
		
		return BUFFER_PROCESSED_OK;
	}
			       

	public void open() throws ResourceUnavailableException {
	}
	
	public void close() {
	}

	public void reset() {
		
	}

	
	public synchronized Object getControl(String controlType) {
		return null;
	}

	public synchronized Object[] getControls() {
		return new Object[0];
	}

	
	public GreyEffect() {
		inputFormats = new Format[] { new RGBFormat(null, Format.NOT_SPECIFIED,
				Format.intArray, Format.NOT_SPECIFIED, 32,
				Format.NOT_SPECIFIED, Format.NOT_SPECIFIED,
				Format.NOT_SPECIFIED) };

		outputFormats = new Format[] { new RGBFormat(null,
				Format.NOT_SPECIFIED, Format.intArray, Format.NOT_SPECIFIED,
				32, Format.NOT_SPECIFIED, Format.NOT_SPECIFIED,
				Format.NOT_SPECIFIED) };
	}

	public Format[] getSupportedInputFormats() {
		return inputFormats;
	}

	public Format[] getSupportedOutputFormats(Format input) {
		if (input == null)
			return (outputFormats);
		if (input instanceof RGBFormat)
			return (new Format[] { input, outputFormats[0] });
		else
			return (outputFormats);
	}

	public Format setInputFormat(Format input) {
		if (input instanceof RGBFormat)
			inputFormat = (RGBFormat) input;
		else
			inputFormat = (RGBFormat) inputFormats[0];
		return (inputFormat);
	}

	public Format setOutputFormat(Format output) {
		if (output instanceof RGBFormat)
			outputFormat = (RGBFormat) output;
		else
			outputFormat = (RGBFormat) outputFormats[0];
		return (outputFormat);
	}

	public String getName() {
		return "grey effect";
	}

	
}
